//***************************************************************************
//***************************************************************************
#define IR_Sensor PORTA.F2
//***************************************************************************
void sony_rx_tick(void)
  {
	Delay_us(289);
  }
//***************************************************************************
// Run the Sony IR Receiver
sony_rx_run(unsigned char sonyir)
{
  unsigned char sony_rx_cmd, sony_rx_addr;
	unsigned char i;
	long b;
	b = 0;
	sony_rx_cmd = 0;
	sony_rx_addr = 0;

do {                    // if no IR present count until 10000,  then return
   if (b == 5000)
      {
      sonyir = 0;
      return sonyir;
      }
   b++;
} while (IR_Sensor == 1);

while(IR_Sensor == 1);   	           // loop and wait for start bit

	for(i = 0; i < 7; i ++)            // confirm start bit
  {
		sony_rx_tick();
		if(IR_Sensor != 0) return;
	}

	while(IR_Sensor == 0);             // wait for the first bit
	sony_rx_tick();
	for(i = 0; i < 7; i ++)
  {
		if(IR_Sensor != 1) return;
		sony_rx_tick();
		sony_rx_tick();
		if(IR_Sensor != 0) return;
		sony_rx_tick();
		sony_rx_tick();
		if(IR_Sensor == 0)
    {
			sony_rx_cmd |= 0x80;
			sony_rx_tick();
			sony_rx_tick();
		}
		sony_rx_cmd = sony_rx_cmd >> 1;
	}
	sony_rx_cmd = sony_rx_cmd & 0x7f;

	for(i = 0; i < 5; i ++)
  {
		if(IR_Sensor != 1) return;
		sony_rx_tick();
		sony_rx_tick();
		if(IR_Sensor != 0) return;
		sony_rx_tick();
		sony_rx_tick();
		if(IR_Sensor == 0)
    {
			sony_rx_addr |= 0x80;
			sony_rx_tick();
			sony_rx_tick();
		}
		sony_rx_addr = sony_rx_addr >> 1;
	}
	sony_rx_addr = sony_rx_addr >> 2;
	sony_rx_addr = sony_rx_addr & 0x1f;
	sonyir = sony_rx_cmd;
	return sonyir;
}//**************************************************************************